routes/web.php
<?php

use App\Constants;
use App\Http\Controllers\Admin\FeedbackController;
use App\Http\Controllers\Admin\SearchController;
use App\Http\Controllers\Admin\UserController;
use App\Http\Controllers\AuthController;
use App\Http\Controllers\DashboardController;
use Illuminate\Support\Facades\Route;
use SebastianBergmann\CodeCoverage\Report\Html\Dashboard;

Route::get('/', [App\Http\Controllers\HomeController::class, 'index'])->name('home');




Route::get('/login', [AuthController::class, 'index'])->name('login.index');
Route::post('/login', [AuthController::class, 'login'])->name('login');

Route::get('/register', [AuthController::class, 'register'])->name('register');
Route::post('/register', [AuthController::class, 'userRegister'])->name('userRegister');

Route::get('result/{username}', [SearchController::class, 'show' ])->name('searsh.show');
Route::post('search', [SearchController::class, 'search'])->name('search');

Route::post('feedbacks/store', [FeedbackController::class, 'store'])->name('feedbacks.store');

Route::group(['middleware' => ['auth']], function () {
    Route::post('/logout', [AuthController::class, 'logout'])->name('logout');

    //Admin
    Route::group(['middleware' => ['auth', 'roleAbilitiesMiddleware:' . Constants::Admin], 'prefix' => 'admin', 'as' => 'admin.'], function () {
        Route::get('/dashboard', [DashboardController::class, 'index'])->name('dashboard.index');
        Route::resource('/searchs', SearchController::class )->except('show');
        Route::resource('/feedbacks', FeedbackController::class )->except('store');
        Route::resource('/users', UserController::class );
        Route::put('/Apikey-Update/{id}', [DashboardController::class, 'updateApiKey' ])->name('apikey.update');
    });
    
    //User
    Route::group(['middleware' => ['auth', 'roleAbilitiesMiddleware:' . Constants::User], 'prefix' => 'user', 'as' => 'user.'], function () {
    });
});

app/Models/Search.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Search extends Model
{
    use HasFactory; 

    protected $fillable = [
        'user_id',
        'username',
        'name',
        'join_date',
        'is_verified',
        'description',
        'location',
        'url',
        'following',
        'followers',
    ];

    public function tweets(){
        return $this->hasMany(Tweets::class);
    }
    
    public function feedbacks(){
        return $this->hasMany(Feedback::class,'searche_id');
    }

    public function user(){
        return $this->belongsTo(User::class);
    }
}

app/Http/Controllers/Admin/SearchController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Http\Requests\SearchRequest;
use App\Models\Search;
use App\Models\SiteInfo;
use App\Models\Tweets;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class SearchController extends Controller
{

    public function index()
    {
        $searchs = Search::all();

        return view('CMS.Searchs.index', compact('searchs'));
    }

    public function search(SearchRequest $request)
    {
        $key = SiteInfo::get()->first();

        $api_url = 'https://www.page2api.com/api/v1/scrape';
        $payload = [
            "api_key" => $key->api_key,
            "url" => "https://twitter.com/" . $request->search,
            "parse" => [
                "name" => "[data-testid=UserName] span >> text",
                "verified" => "js >> document.querySelectorAll('[data-testid=UserName] svg[role=img]').length == 1",
                "description" => "[data-testid=UserDescription] >> text",
                "location" => "span[data-testid=UserLocation] >> text",
                "url" => "a[data-testid=UserUrl] >> text",
                "join_date" => "span[data-testid=UserJoinDate] >> text",
                "following" => "a[href*=following] > span > span >> text",
                "followers" => "a[href*=followers] > span > span >> text",
                "latest_tweets" => [
                    "0" => [
                        "_parent" => "[data-testid=tweet]",
                        "name" => "[data-testid='User-Names'] a >> text",
                        "user_url" => "[data-testid='User-Names'] a >> href",
                        "content" => "div[data-testid=tweetText] >> text",
                        "timestamp" => "time >> datetime",
                        "retweets" => "div[data-testid=retweet] >> text",
                        "likes" => "div[data-testid=like] >> text",
                        "replies" => "div[data-testid=reply] >> text"
                    ]
                ]
            ],
            "wait_for" => "[data-testid=tweet]",
            "premium_proxy" => "us",
            "real_browser" => true
        ];

        $postdata = json_encode($payload);
        $ch = curl_init($api_url);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $postdata);
        curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type:application/json'));
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        $result = curl_exec($ch);
        curl_close($ch);
        $data = json_decode($result, true);
        if (isset($data['error'])) {
            return redirect()->route('home')->with('success', 'Not Found');
        }
        return $this->store($data['result'], $request->search);
    }

    public function store($data, $username)
    {

        $search = Search::create([
            'user_id' => Auth::check() ? Auth::id() : null,
            'username' => $username,
            'name' => $data['name'],
            'is_verified' => $data['verified'],
            'description' => $data['description'],
            'location' => $data['location'],
            'url' => $data['url'],
            'join_date' => $data['join_date'],
            'following' => $data['following'],
            'followers' => $data['followers'],
        ]);
        $data['latest_tweets'];

        $latest_tweets = [];
        $i = 0;
        foreach ($data['latest_tweets'] as $item) {
            $latest_tweets[$i] = [
                'name' => $item['name'],
                'content' => $item['content'],
                'retweets' => $item['retweets'],
                'likes' => $item['likes'],
                'replies' => $item['replies'],
                'search_id' => $search->id,
            ];
            $i++;
        }
        Tweets::insert($latest_tweets);

        return redirect()->route('searsh.show', $username);
    }

    public function show($username)
    {
        $result = Search::with('tweets')->where('username', $username)->first();
        return view('CMS.Searchs.show', compact('result'));
    }

    public function destroy($id)
    {
        $result = Search::find($id);

        $result->delete();
        return 'Deleted Successfully';
    }
}

resources/views/CMS/Searchs/index.blade.php
@extends('CMS.layouts.app')
@section('content')
    <div class="container-xxl flex-grow-1 container-p-y">
        <h4 class="fw-bold py-3 mb-4"><span class="text-muted fw-light">Dashboard /</span> Searchs Logs</h4>

        <!-- Basic Bootstrap Table -->

        <div class="card h-100">
            <div class="row">
                <div class="col-lg-10 col-12">
                    <h5 class="card-header">Searchs Logs</h5>
                </div>
                <div class="col-lg-2 col-12 p-3">
                    {{-- <a href="{{ route('Searchs.create') }}" class="btn btn-primary btn-block w-100 ">
                        اضافة عضو
                    </a> --}}
                </div>
            </div>
            <div class="table-responsive text-nowrap h-100">

                <table class="table">
                    <thead>
                        <tr>
                            <th>Id</th>
                            <th>Name</th>
                            <th>Username</th>
                            <th>Location</th>
                            <th>Followers</th>
                            <th>Is Verified</th>
                            <th>Action</th>
                        </tr>
                    </thead>
                    <tbody class="table-border-bottom-1 ">
                        @include('CMS.Searchs.table')
                    </tbody>
                </table>
            </div>
        </div>
        <hr class="my-5" />
    </div>
@endsection

resources/views/CMS/Searchs/show.blade.php
@extends('layouts.app')
@section('style')
@endsection
@section('content')

<style>
  .user_name{
    font: normal normal 600 37px/27px Segoe UI;
    color: rgb(130, 121, 121)
  }
  .details{
    font: normal normal 600 20px/20px Segoe UI;
    line-height: 40px;
  }
  .sec{
    
    background-color: rgb(252, 254, 254);
    padding: 40px;
    border-top: solid rgb(215, 209, 209) 1px;
  }
</style>
<section class="container mt-5">
  <h1 class="user_name" > <i class="fa fa-user-circle" aria-hidden="true"></i>
    {{$result->username}} </h1>
  <h4 class="details mt-3">{{$result->description}}</h4>

  <div class="row mt-4">
    <div class="col-md-6">
        <h4 class="details"><i class="fa fa-user" aria-hidden="true"></i> Name : {{$result->name}}</h4>
        
        <h4 class="details"> <i class="fa fa-check" aria-hidden="true"></i>  Is Verified 
          @if ($result->is_verified == 0)
          : <span class="badge me-1 bg-label-danger"> Not Verified</span>
          @else
          : <span class="badge me-1 bg-label-success"> Verified</span> 
          @endif
        </h4>
      <h4 class="details"><i class="fa fa-location-arrow" aria-hidden="true"></i> Location  : {{$result->location}}</h4>

    </div>

    <div class="col-md-6">
      <h4 class="details"> <i class="fa fa-link" aria-hidden="true"></i> URL  : {{$result->url}}</h4>
      <h4 class="details"> <i class="fa fa-plus" aria-hidden="true"></i> Following  : {{$result->following}}</h4>
      <h4 class="details"> <i class="fa fa-address-book" aria-hidden="true"></i> Followers : {{$result->followers}}</h4>

    </div>
    <br>
  </div>

  
</section>

<section class="container-fluid mt-5 sec">
  <div class="container">
    <h1 class="user_name" style="color:#0088be;">Latest Tweets  <i class="fa-brands fa-twitter" ></i> </h1>
    @if ($result->tweets->count())
    @foreach ($result->tweets as $item)
      <div class="row mt-4">
        <div class="col-md-6">
          <h4 class="details">{{$item->name}}</h4>
          <h4 class="details"> {{$item->content}}</h4>  
        </div>
    
        <div class="col-md-6">
          <h4 class="details"><i class="fa fa-thumbs-up" aria-hidden="true" ></i> Likes  : {{$item->likes}}</h4>
          <h4 class="details"> <i class="fa-brands fa-twitter" ></i> Retweets : {{$item->retweets}}</h4>
          <h4 class="details"><i class="fa-solid fa-reply"></i> Replies  : {{$item->replies}}</h4>
        </div>
        <br>
        <hr class="mt-4">
      </div>
    @endforeach
    @else
    <h4 class="details">No Tweets Found</h4>
    @endif
    
    
  </div>
 
</section>

<section class="container mt-5">
  <h1 class="user_name"> Write Your Feedack</i>
  <div class="row mt-4">
    <div class="col-md-12">
      <form method="POST" action="{{ route('feedbacks.store') }}">
        @csrf
        <input type="hidden" name="searche_id" value="{{$result->id}}">
        <div class="mb-3">

            <textarea id="feed" type="text" class="form-control @error('feed') is-invalid @enderror inp"
                name="feed"  required>{{ old('feed') }}</textarea>
            @error('feed')
                <span class="invalid-feedback" role="alert">
                    <strong>{{ $message }}</strong>
                </span>
            @enderror
        </div>
        <div class="row mb-0">
            <div class="col-md-8">
                <button type="submit" class="btn btn-primary"
                    style="background: #0088b; color:white;">
                    {{ __('submit') }}
                </button>
            </div>
        </div>
    </form>    </div>

    <br>
  </div>

  
</section>
@endsection

resources/views/CMS/Searchs/table.blade.php
@foreach ($searchs as $search)
    <tr>
        <td>{{ $search->id }}</td>
        <td>{{ $search->name}}</td>
        <td>{{ $search->username}}</td>
        
        <td>{{ $search->location }}</td>
        <td>{{ $search->followers }}</td>
        @if ($search->is_verified == true)
        <td> <span class="badge me-1 bg-label-success"> Verified</span></td>
        @else
        <td> <span class="badge me-1 bg-label-danger"> Not Verified</span></td>
        @endif
        <td>
            <div class="dropdown">
                <button type="button" class="btn p-0 dropdown-toggle hide-arrow" data-bs-toggle="dropdown">
                    <i class="bx bx-dots-vertical-rounded"></i>
                </button>
                <div class="dropdown-menu">
                    <a class="dropdown-item" href="{{ route('searsh.show', $search->username) }}"><i
                            class="bx bx-edit-alt me-1"></i>
                        Show </a>
                    <a class="dropdown-item deleteItem" data-url='{{ route('admin.searchs.destroy', $search->id) }}'
                        href="#"><i class="bx bx-trash me-1"></i>
                        Delete</a>
                </div>
            </div>
        </td>
    </tr>
@endforeach